SystemOrganization addCategory: #AMB!


Object subclass: #AMB
	instanceVariableNames: 'failContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMB'!

PackageInfo subclass: #AMBInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMB'!

TestCase subclass: #AMBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMB'!

AMB class
	instanceVariableNames: ''!

AMBInfo class
	instanceVariableNames: ''!

AMBTest class
	instanceVariableNames: ''!


!AMB commentStamp: '<historical>' prior: 0!
this is the "ambigous", "nondeterminist", "angelic" operator aka amb

... more seriously described as a declarative control flow statement able to enumerate over finite domains all values that make a program terminate. it uses continuations to walk the tree of possible tuples, backtracking when the program fails. 

the amazing thing is the simplicity of the code: four short or very short methods on the instance side, the class side methods only providing syntactic sugar.

and it can do incredible things such as:

AMB assert: [:string :n :char | (string occurrencesOf: char) = n]
	over: #('maman' 'barbapapa' 'guiliguili' 'arthur' 'chtulu')
	and: #(2 4 1)
	and: #($m $b $a $i $u)

see AMBTest for more magic.

I would have been unable to implement this by myself !! this is a port of the code by Dorai Sitaram which is the reference documentation for amb:

http://www.ccs.neu.edu/home/dorai/t-y-scheme/t-y-scheme-Z-H-16.html#node_chap_14

Stef (spfa)
!
]style[(861 80 14)f3,c000124000i,f3!

!AMB methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 16:47'!
assert: aBoolean

	aBoolean ifFalse: [self next]! !

!AMB class methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:26'!
assert: aBlock over: aCollection

	^ self bagOf: [:amb | | x |
						x _ amb try: aCollection.
						amb assert: (aBlock value: x).
						x]! !

!AMB class methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:28'!
assert: aBlock over: aCollection and: bCollection

	^ self bagOf: [:amb | | x y |
						x _ amb try: aCollection.
						y _ amb try: bCollection.
						amb assert: (aBlock value: x value: y).
						{x . y}]! !

!AMB class methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:29'!
assert: aBlock over: aCollection and: bCollection and: cCollection

	^ self bagOf: [:amb | | x y z |
						x _ amb try: aCollection.
						y _ amb try: bCollection.
						z _ amb try: cCollection.
						amb assert: (aBlock value: x value: y value: z).
						{x . y . z}]! !

!AMB class methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:19'!
bagOf: aBlock

	| coll amb |

	coll _ OrderedCollection new.
	amb _ self new.
	[
		coll add: (aBlock value: amb).
		[coll add: amb next] repeat 
	]
	on: Error do: [^ coll]

! !

!AMB methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 16:48'!
initialize

	failContinuation _ [self error: 'AMB tree exhausted']! !

!AMB methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 16:32'!
next

	^ self try: #()! !

!AMBInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:25'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('Continuation') ! !

!AMBInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:28'!
readmeText

	^ ''! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:18'!
testAssertOver2Domains

	| comb |

	comb _ AMB assert: [:x :y | (x * 2) = y] 
				over: #(1 2 3 4 7 9) and: #(5 4 3 14). 

	self assert: comb asArray = #((2 4) (7 14))! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:54'!
testAssertOver3Domains

	| comb |

	comb _AMB assert: [:string :n :char | (string occurrencesOf: char) = n]
		over: #('maman' 'barbapapa' 'guiliguili' 'arthur' 'chtulu')
		and: #(2 4 1)
		and: #($m $b $a $i $u).

	self assert: (comb asArray = #(('maman' 2 $m) ('maman' 2 $a) ('barbapapa' 2 $b) ('barbapapa' 4 $a) ('guiliguili' 2 $u) ('guiliguili' 4 $i) ('arthur' 1 $a) ('arthur' 1 $u) ('chtulu' 2 $u)))! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:52'!
testAssertOverADomain

	| comb |

	comb _AMB assert: [:x | x *x = 1] over: #(1 2 3 -1 -2).

	self assert: comb asArray = #(1 -1)! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:17'!
testBasics

	| amb x |

	amb _ AMB new.

	x _ amb try: #(1 2 3).

	self assert: x = 1.

	"how can we test here for the next values ? tricky because of the continuation"
! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:09'!
testBasics2

	| amb x |

	amb _ AMB new.
	x _ amb try: #(1 2 3 4).
	(x * 2) = 6 ifFalse: [amb next].

	self assert: x = 3.
	! !

!AMBTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 18:17'!
testBasics3

	| amb x y |

	amb _ AMB new.
	x _ amb try: #(1 2 3 4).
	y _ amb try: #(5 4 3 8).
	(x * 2) = y ifFalse: [amb next].

	self assert: x = 2.
	self assert: y = 4.

	"how can we test here for the next pair of values ?"

	
	! !

!AMB methodsFor: 'as yet unclassified' stamp: 'spfa 6/30/2008 17:23'!
try: anArray

	| prev | 

	prev _ failContinuation.

	^ Continuation currentDo: [:c |
		anArray do: [:alt |
			Continuation currentDo: [:calt |
				failContinuation _ [
										failContinuation _ prev. 
										calt value: #fail
									] fixTemps.
				c value: alt]].
		^ prev value]! !
